diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 76522382f..59dd489e1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -17,6 +17,7 @@ import net.minecraft.core.entity.animal.MobPig;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.weather.IPrecipitation;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.joml.Matrix4f;
 import org.joml.Vector3d;
 import org.joml.Vector3dc;
@@ -69,7 +70,7 @@ public class WorldRenderer {
     public float farPlaneDistance;
     public ItemRenderer itemRenderer;
     public FogManager fogManager;
-    private int rendererUpdateCount;
+    private int tick;
     private Entity pointedEntity;
     private final MouseFilter mouseFilterXAxis;
     private final MouseFilter mouseFilterYAxis;
@@ -107,7 +108,7 @@ public class WorldRenderer {
 
         this.fogManager.updateBrightness();
 
-        this.rendererUpdateCount++;
+        this.tick++;
         this.itemRenderer.updateEquippedItem();
         addRainParticles();
         this.lightmapHelper.tick();
@@ -330,7 +331,7 @@ public class WorldRenderer {
         if (portalIntensity > 0.0F) {
             float f3 = 5F / (portalIntensity * portalIntensity + 5F) - portalIntensity * 0.04F;
             f3 *= f3;
-            float rotation = org.joml.Math.toRadians(((float) this.rendererUpdateCount + partialTick) * 20F);
+            float rotation = org.joml.Math.toRadians(((float) this.tick + partialTick) * 20F);
             matrix.rotate(rotation, 0.0F, 0.7071f, 0.7071f);
             matrix.scale(1.0F / f3, 1.0F, 1.0F);
             matrix.rotate(-rotation, 0.0F, 0.7071f, 0.7071f);
@@ -715,7 +716,7 @@ public class WorldRenderer {
         GLRenderer.setDepthMask(true);
         GLRenderer.enableState(State.CULL_FACE);
         GLRenderer.disableState(State.BLEND);
-        renderRainSnow(partialTicks);
+        renderPrecipitation(partialTicks);
         if (GameSettings.CLOUDS.value) {
             Debug.change("clouds");
             GLRenderer.pushFrame();
@@ -739,255 +740,205 @@ public class WorldRenderer {
 
     private void addRainParticles() {
         if (GameSettings.PARTICLES_QUALITY.value == ParticlesQuality.NONE) return;
-        Weather weather = this.mc.currentWorld.getCurrentWeather();
-        if (!(weather instanceof IPrecipitation precipitation) || !precipitation.spawnRainParticles()) return;
 
-        float f = this.mc.currentWorld.getWeatherManager().getWeatherIntensity() * this.mc.currentWorld.getWeatherManager().getWeatherPower();
+        final @Nullable World world = this.mc.currentWorld;
+        if (world == null) {
+            return;
+        }
+
+        final @Nullable Weather weather = world.getCurrentWeather();
+        if (!(weather instanceof IPrecipitation precipitation) || !precipitation.spawnRainParticles()) {
+            return;
+        }
 
+        float rainLevel = world.getWeatherManager().getWeatherIntensity() * world.getWeatherManager().getWeatherPower();
         if (GameSettings.PARTICLES_QUALITY.value == ParticlesQuality.REDUCED) {
-            f /= 2.0F;
+            rainLevel /= 2.0F;
         }
-        if (f == 0.0F) {
+        if (rainLevel == 0.0F) {
             return;
         }
-        this.random.setSeed((long) this.rendererUpdateCount * 0x12a7ce5fL);
-        World world = this.mc.currentWorld;
+
+        this.random.setSeed((long) this.tick * 0x12a7ce5fL);
         int cameraX = MathHelper.floor(this.mc.activeCamera.getX());
         int cameraY = MathHelper.floor(this.mc.activeCamera.getY());
         int cameraZ = MathHelper.floor(this.mc.activeCamera.getZ());
-        byte byte0 = 10;
-        double d = 0.0D;
-        double d1 = 0.0D;
-        double d2 = 0.0D;
-        int l = 0;
-        blockedWeather:
-        for (int i1 = 0; i1 < (int) (100F * f * f); i1++) {
-            int randX = (cameraX + this.random.nextInt(byte0)) - this.random.nextInt(byte0);
-            int randZ = (cameraZ + this.random.nextInt(byte0)) - this.random.nextInt(byte0);
-            int y = world.findTopSolidBlock(randX, randZ);
-            int i2 = world.getBlockId(randX, y - 1, randZ);
-
-            Biome biome = world.getBlockBiome(randX, y, randZ);
-            for (int q = 0; q < biome.blockedWeathers.length; q++) {
-                if (biome.blockedWeathers[q] == weather) continue blockedWeather;
+
+        final byte weatherDiameter = 10;
+
+        double rainParticlePositionX = 0.0D;
+        double rainParticlePositionY = 0.0D;
+        double rainParticlePositionZ = 0.0D;
+
+        int spawnedParticles = 0;
+        for (int ii = 0; ii < (int) (100F * rainLevel * rainLevel); ii++) {
+            int x = (cameraX + this.random.nextInt(weatherDiameter)) - this.random.nextInt(weatherDiameter);
+            int z = (cameraZ + this.random.nextInt(weatherDiameter)) - this.random.nextInt(weatherDiameter);
+            int heightmapPosition = world.findTopSolidBlock(x, z);
+            int blockId = world.getBlockId(x, heightmapPosition - 1, z);
+
+            final @NotNull Biome biome = world.getBlockBiome(x, heightmapPosition, z);
+            if (biome.blockedWeathers.contains(weather)) {
+                continue;
             }
 
-            if (y > cameraY + byte0 || y < cameraY - byte0) {
+            if (heightmapPosition > cameraY + weatherDiameter || heightmapPosition < cameraY - weatherDiameter) {
                 continue;
             }
-            float f1 = this.random.nextFloat();
-            float f2 = this.random.nextFloat();
-            if (i2 <= 0) {
+            final float blockX = this.random.nextFloat();
+            final float blockZ = this.random.nextFloat();
+
+            if (blockId == Blocks.AIR.id()) {
                 continue;
             }
-            if (Blocks.blocksList[i2].getMaterial() == Materials.LAVA) {
-                this.mc.particleEngine.add(new ParticleSmoke(world, (float) randX + f1, (double) ((float) y + 0.1F) - Blocks.blocksList[i2].getBounds().minY(), (float) randZ + f2, 0.0D, 0.0D, 0.0D, 1.0f, 0));
+
+            if (Blocks.blocksList[blockId].getMaterial() == Materials.LAVA) {
+                this.mc.particleEngine.add(new ParticleSmoke(world, x + blockX, (heightmapPosition + 0.1F) - Blocks.blocksList[blockId].getBounds().minY(), z + blockZ, 0.0D, 0.0D, 0.0D, 1.0f, 0));
                 continue;
             }
-            if (this.random.nextInt(++l) == 0) {
-                d = (float) randX + f1;
-                d1 = (double) ((float) y + 0.1F) - Blocks.blocksList[i2].getBounds().minY();
-                d2 = (float) randZ + f2;
+
+            if (this.random.nextInt(++spawnedParticles) == 0) {
+                rainParticlePositionX = x + blockX;
+                rainParticlePositionY = (heightmapPosition + 0.1F) - Blocks.blocksList[blockId].getBounds().minY();
+                rainParticlePositionZ = z + blockZ;
             }
-            this.mc.particleEngine.add(new ParticleWaterDrop(world, (float) randX + f1, (double) ((float) y + 0.1F) - Blocks.blocksList[i2].getBounds().minY(), (float) randZ + f2));
+            this.mc.particleEngine.add(new ParticleWaterDrop(world, x + blockX, (heightmapPosition + 0.1F) - Blocks.blocksList[blockId].getBounds().minY(), z + blockZ));
         }
 
-        if (l > 0 && this.random.nextInt(3) < this.rainSoundCounter++) {
+        if (spawnedParticles > 0 && this.random.nextInt(3) < this.rainSoundCounter++) {
             this.rainSoundCounter = 0;
-            if (d1 > this.mc.activeCamera.getY() + 1.0D && world.getHeightValue(MathHelper.floor(this.mc.activeCamera.getX()), MathHelper.floor(this.mc.activeCamera.getZ())) > MathHelper.floor(this.mc.activeCamera.getY())) {
-                this.mc.currentWorld.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, d, d1, d2, "ambient.weather.rain", 0.1F * this.mc.currentWorld.getWeatherManager().getWeatherIntensity() * this.mc.currentWorld.getWeatherManager().getWeatherPower() * 0.5f, 0.5F);
+
+            float volume;
+            float pitch;
+            if (rainParticlePositionY > this.mc.activeCamera.getY() + 1.0D && world.getHeightValue(MathHelper.floor(this.mc.activeCamera.getX()), MathHelper.floor(this.mc.activeCamera.getZ())) > MathHelper.floor(this.mc.activeCamera.getY())) {
+                volume = 0.1f;
+                pitch = 0.5f;
             } else {
-                this.mc.currentWorld.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, d, d1, d2, "ambient.weather.rain", 0.2F * this.mc.currentWorld.getWeatherManager().getWeatherIntensity() * this.mc.currentWorld.getWeatherManager().getWeatherPower() * 0.5f, 1.0F);
+                volume = 0.2f;
+                pitch = 1.0f;
             }
+
+            this.mc.currentWorld.playSoundEffect(
+                null,
+                SoundCategory.WEATHER_SOUNDS,
+                rainParticlePositionX, rainParticlePositionY, rainParticlePositionZ,
+                "ambient.weather.rain",
+                volume * this.mc.currentWorld.getWeatherManager().getWeatherIntensity() * this.mc.currentWorld.getWeatherManager().getWeatherPower() * 0.5f,
+                pitch
+            );
         }
     }
 
-    protected void renderRainSnow(float partialTick) {
-        Weather weather = this.mc.currentWorld.getCurrentWeather();
-        if (!(weather instanceof @NotNull IPrecipitation precipitation)) return;
+    protected void renderPrecipitation(final float partialTick) {
+        final @Nullable World world = this.mc.currentWorld;
+        if (world == null) {
+            return;
+        }
+
+        final @Nullable Weather weather = world.getCurrentWeather();
+        if (!(weather instanceof @NotNull IPrecipitation precipitation)) {
+            return;
+        }
+
+        final int cameraBlockX = MathHelper.floor(this.mc.activeCamera.getX());
+        final int cameraBlockY = MathHelper.floor(this.mc.activeCamera.getY());
+        final int cameraBlockZ = MathHelper.floor(this.mc.activeCamera.getZ());
+
+        final @NotNull TessellatorGeneral t = GLRenderer.getTessellator();
 
-        World world = this.mc.currentWorld;
-        int posX = MathHelper.floor(this.mc.activeCamera.getX());
-        int posY = MathHelper.floor(this.mc.activeCamera.getY());
-        int posZ = MathHelper.floor(this.mc.activeCamera.getZ());
-        TessellatorGeneral tessellator = GLRenderer.getTessellator();
         GLRenderer.pushFrame();
         GLRenderer.setShader(Shaders.WORLD);
         GLRenderer.setLightmapCoord2i(15, 15);
         GLRenderer.disableState(State.CULL_FACE);
-//        glNormal3f(0.0F, 1.0F, 0.0F);
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
-//        glAlphaFunc(516, 0.01F);
 
         this.mc.textureManager.loadTexture(precipitation.getPrecipitationTexturePath(world.getWeatherManager().getWeatherPower(), world.getWeatherManager().getWeatherIntensity())).bind();
 
-        double nextPosX = this.mc.activeCamera.getX(partialTick);
-        double nextPosY = this.mc.activeCamera.getY(partialTick);
-        double nextPosZ = this.mc.activeCamera.getZ(partialTick);
-        int floorPosY = MathHelper.floor(nextPosY);
-        int radiusEffect = 10;
-
-        TilePos queryPos = new TilePos();
-
-        if (precipitation.getPrecipitationType() == IPrecipitation.Type.SNOW_LIKE) {
-            tessellator.startDrawingQuads();
-            for (int x = posX - radiusEffect; x <= posX + radiusEffect; x++) {
-                blockedWeather:
-                for (int z = posZ - radiusEffect; z <= posZ + radiusEffect; z++) {
-                    int y = world.findTopSolidBlock(x, z);
-                    Biome biomegenbase = world.getBlockBiome(x, y, z);
-                    for (int q = 0; q < biomegenbase.blockedWeathers.length; q++) {
-                        if (biomegenbase.blockedWeathers[q] == weather) {
-                            continue blockedWeather;
-                        }
-                    }
-                    if (y < 0) {
-                        y = 0;
-                    }
-                    int i3 = y;
-                    if (i3 < floorPosY) {
-                        i3 = floorPosY;
-                    }
-                    int k3 = posY - radiusEffect;
-                    int i4 = posY + radiusEffect;
-                    if (k3 < y) {
-                        k3 = y;
-                    }
-                    if (i4 < y) {
-                        i4 = y;
-                    }
-                    float f3 = 1.0F;
-                    if (k3 != i4) {
-                        this.random.setSeed((long) x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abbL + (long) z * z * 0x66397 + z * 13761L);
-                        float f5 = (float) this.rendererUpdateCount + partialTick;
-                        float f6 = ((float) (this.rendererUpdateCount & 0x1ff) + partialTick) / 512F;
-                        float f7 = this.random.nextFloat() + f5 * 0.01F * (float) this.random.nextGaussian();
-                        float f8 = this.random.nextFloat() + f5 * (float) this.random.nextGaussian() * 0.001F;
-                        double d5 = (double) ((float) x + 0.5F) - this.mc.activeCamera.getX();
-                        double d6 = (double) ((float) z + 0.5F) - this.mc.activeCamera.getZ();
-                        float f11 = MathHelper.sqrt(d5 * d5 + d6 * d6) / (float) radiusEffect;
-                        float brightness;
-                        if (this.mc.fullbright) {
-                            brightness = 1.0f;
-                        } else {
-                            brightness = world.getLightBrightness(queryPos.set(x, i3, z));
-                        }
-                        tessellator.setColor4f(brightness, brightness, brightness, ((1.0F - f11 * f11) * 0.3F + 0.5F) * world.getWeatherManager().getWeatherIntensity() * world.getWeatherManager().getWeatherPower());
-                        tessellator.setTranslation(-nextPosX, -nextPosY, -nextPosZ);
-                        tessellator.addVertexWithUV(x, k3, (double) z + 0.5D, 0.0F * f3 + f7, ((float) k3 * f3) / 4F + f6 * f3 + f8);
-                        tessellator.addVertexWithUV(x + 1, k3, (double) z + 0.5D, f3 + f7, ((float) k3 * f3) / 4F + f6 * f3 + f8);
-                        tessellator.addVertexWithUV(x + 1, i4, (double) z + 0.5D, f3 + f7, ((float) i4 * f3) / 4F + f6 * f3 + f8);
-                        tessellator.addVertexWithUV(x, i4, (double) z + 0.5D, 0.0F * f3 + f7, ((float) i4 * f3) / 4F + f6 * f3 + f8);
-
-                        tessellator.addVertexWithUV((double) x + 0.5D, k3, z, 0.0F * f3 + f7, ((float) k3 * f3) / 4F + f6 * f3 + f8);
-                        tessellator.addVertexWithUV((double) x + 0.5D, k3, z + 1, f3 + f7, ((float) k3 * f3) / 4F + f6 * f3 + f8);
-                        tessellator.addVertexWithUV((double) x + 0.5D, i4, z + 1, f3 + f7, ((float) i4 * f3) / 4F + f6 * f3 + f8);
-                        tessellator.addVertexWithUV((double) x + 0.5D, i4, z, 0.0F * f3 + f7, ((float) i4 * f3) / 4F + f6 * f3 + f8);
-                        tessellator.setTranslation(0.0D, 0.0D, 0.0D);
-                    }
-                }
-            }
-            tessellator.draw();
-        } else if (precipitation.getPrecipitationType() == IPrecipitation.Type.RAIN_LIKE) {
-            tessellator.startDrawingQuads();
-            for (int x = posX - radiusEffect; x <= posX + radiusEffect; x++) {
-                blockedWeather:
-                for (int z = posZ - radiusEffect; z <= posZ + radiusEffect; z++) {
-                    int y = world.findTopSolidBlock(x, z);
-                    Biome biome = world.getBlockBiome(x, y, z);
-                    for (int q = 0; q < biome.blockedWeathers.length; q++) {
-                        if (biome.blockedWeathers[q] == weather) {
-                            continue blockedWeather;
-                        }
-                    }
-                    int j3 = posY - radiusEffect;
-                    int l3 = posY + radiusEffect;
-                    if (j3 < y) {
-                        j3 = y;
-                    }
-                    if (l3 < y) {
-                        l3 = y;
-                    }
-                    float f2 = 1.0F;
-                    if (j3 != l3) {
-                        this.random.setSeed((long) x * x * 3121 + x * 0x2b24abbL + (long) z * z * 0x66397 + z * 13761L);
-                        float f4 = (((float) (this.rendererUpdateCount + x * x * 3121 + x * 0x2b24abb + z * z * 0x66397 + z * 13761 & 0x1f) + partialTick) / 32F) * (3F + this.random.nextFloat());
-                        double d3 = (double) ((float) x + 0.5F) - this.mc.activeCamera.getX();
-                        double d4 = (double) ((float) z + 0.5F) - this.mc.activeCamera.getZ();
-                        float f9 = MathHelper.sqrt(d3 * d3 + d4 * d4) / (float) radiusEffect;
-
-                        float brightness;
-                        if (this.mc.fullbright) {
-                            brightness = 1.0f;
-                        } else {
-                            brightness = world.getLightBrightness(queryPos.set(x, world.getHeightBlocks(), z)) * 0.85F + 0.15F;
-                        }
-                        tessellator.setTranslation(-nextPosX, -nextPosY, -nextPosZ);
-                        tessellator.setColor4f(brightness, brightness, brightness, ((1.0F - f9 * f9) * 0.5F + 0.5F) * (world.getWeatherManager().getWeatherIntensity() - 0.1f) * world.getWeatherManager().getWeatherPower());
-                        tessellator.addVertexWithUV(x, j3, (double) z + 0.5D, 0.0F * f2, ((float) j3 * f2) / 4F + f4 * f2);
-                        tessellator.addVertexWithUV(x + 1, j3, (double) z + 0.5D, f2, ((float) j3 * f2) / 4F + f4 * f2);
-                        tessellator.addVertexWithUV(x + 1, l3, (double) z + 0.5D, f2, ((float) l3 * f2) / 4F + f4 * f2);
-                        tessellator.addVertexWithUV(x, l3, (double) z + 0.5D, 0.0F * f2, ((float) l3 * f2) / 4F + f4 * f2);
-
-                        tessellator.addVertexWithUV((double) x + 0.5D, j3, z, 0.0F * f2, ((float) j3 * f2) / 4F + f4 * f2);
-                        tessellator.addVertexWithUV((double) x + 0.5D, j3, z + 1, f2, ((float) j3 * f2) / 4F + f4 * f2);
-                        tessellator.addVertexWithUV((double) x + 0.5D, l3, z + 1, f2, ((float) l3 * f2) / 4F + f4 * f2);
-                        tessellator.addVertexWithUV((double) x + 0.5D, l3, z, 0.0F * f2, ((float) l3 * f2) / 4F + f4 * f2);
-                        tessellator.setTranslation(0.0D, 0.0D, 0.0D);
-                    }
+        final double lerpedX = this.mc.activeCamera.getX(partialTick);
+        final double lerpedY = this.mc.activeCamera.getY(partialTick);
+        final double lerpedZ = this.mc.activeCamera.getZ(partialTick);
+
+        final int radius = 10;
+
+        final @NotNull TilePos queryPos = new TilePos();
+
+        t.startDrawingQuads();
+
+        for (int x = cameraBlockX - radius; x <= cameraBlockX + radius; x++) {
+            for (int z = cameraBlockZ - radius; z <= cameraBlockZ + radius; z++) {
+                final int terrainHeight = Math.max(world.findTopSolidBlock(x, z), 0);
+                queryPos.set(x, terrainHeight, z);
+
+                final @NotNull Biome biome = world.getBlockBiome(queryPos);
+                if (biome.blockedWeathers.contains(weather)) {
+                    continue;
                 }
-            }
-            tessellator.draw();
-        } else if (precipitation.getPrecipitationType() == IPrecipitation.Type.INVERTED_RAIN_LIKE) {
-            tessellator.startDrawingQuads();
-            for (int x = posX - radiusEffect; x <= posX + radiusEffect; x++) {
-                blockedWeather:
-                for (int z = posZ - radiusEffect; z <= posZ + radiusEffect; z++) {
-                    int topSolidY = world.findTopSolidBlock(x, z);
-                    Biome biome = world.getBlockBiome(x, topSolidY, z);
-                    for (int i = 0; i < biome.blockedWeathers.length; i++) {
-                        if (biome.blockedWeathers[i] == weather) {
-                            continue blockedWeather;
-                        }
-                    }
-                    int j3 = posY - radiusEffect;
-                    int l3 = posY + radiusEffect;
-                    if (j3 < topSolidY) {
-                        j3 = topSolidY;
-                    }
-                    if (l3 < topSolidY) {
-                        l3 = topSolidY;
+
+                int y0 = Math.max(cameraBlockY - radius, terrainHeight);
+                int y1 = Math.max(cameraBlockY + radius, terrainHeight);
+
+                if (y0 != y1) {
+                    final long seed = x * x * 3121L + x * 45238971L + z * z * 418711L + z * 13761L;
+                    this.random.setSeed(seed);
+
+                    final double relativeX = (x + 0.5) - this.mc.activeCamera.getX(partialTick);
+                    final double relativeZ = (z + 0.5) - this.mc.activeCamera.getZ(partialTick);
+                    final float distanceSq = MathHelper.sqrt(relativeX * relativeX + relativeZ * relativeZ) / radius;
+
+                    float br;
+                    if (this.mc.fullbright) {
+                        br = 1.0f;
+                    } else {
+                        br = world.getLightBrightness(queryPos);
                     }
-                    float f2 = 1.0F;
-                    if (j3 != l3) {
-                        this.random.setSeed((long) x * x * 3121 + x * 0x2b24abbL + (long) z * z * 0x66397 + z * 13761L);
-                        float vOffset = (((float) (this.rendererUpdateCount + x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abb + z * z * 0x66397 + z * 13761 & 0x1f) + partialTick) / 32F) * (3F + this.random.nextFloat());
-                        double d3 = (double) ((float) x + 0.5F) - this.mc.activeCamera.getX();
-                        double d4 = (double) ((float) z + 0.5F) - this.mc.activeCamera.getZ();
-                        float f9 = MathHelper.sqrt(d3 * d3 + d4 * d4) / (float) radiusEffect;
-                        float brightness;
-                        if (this.mc.fullbright) {
-                            brightness = 1.0f;
-                        } else {
-                            brightness = world.getLightBrightness(queryPos.set(x, world.getHeightBlocks(), z)) * 0.85F + 0.15F;
+
+                    float u, v, vOffset;
+
+                    if (precipitation.getPrecipitationType() == IPrecipitation.Type.SNOW_LIKE) {
+                        final float time = this.tick + partialTick;
+
+                        vOffset = ((this.tick & 0x1ff) + partialTick) / 512F;
+                        u = this.random.nextFloat() + time * 0.01F * (float) this.random.nextGaussian();
+                        v = this.random.nextFloat() + time * (float) this.random.nextGaussian() * 0.001F;
+
+                        t.setColor4f(br, br, br, ((1.0F - distanceSq * distanceSq) * 0.3F + 0.5F) * world.getWeatherManager().getWeatherIntensity() * world.getWeatherManager().getWeatherPower());
+                    } else if (precipitation.getPrecipitationType() == IPrecipitation.Type.RAIN_LIKE || precipitation.getPrecipitationType() == IPrecipitation.Type.INVERTED_RAIN_LIKE) {
+                        final float blockPosRainSpeed = 3.0F + this.random.nextFloat();
+
+                        vOffset = ((this.tick + seed & 0x1f) + partialTick) / 32F * blockPosRainSpeed;
+                        u = 0.0f;
+                        v = 0.0f;
+
+                        br *= 0.85f + 0.15f;
+
+                        t.setColor4f(br, br, br, ((1.0F - distanceSq * distanceSq) * 0.5F + 0.5F) * (world.getWeatherManager().getWeatherIntensity() - 0.1f) * world.getWeatherManager().getWeatherPower());
+
+                        if (precipitation.getPrecipitationType() == IPrecipitation.Type.INVERTED_RAIN_LIKE) {
+                            vOffset = -vOffset;
                         }
-                        tessellator.setColor4f(brightness, brightness, brightness, ((1.0F - f9 * f9) * 0.5F + 0.5F) * (world.getWeatherManager().getWeatherIntensity() - 0.1f) * world.getWeatherManager().getWeatherPower());
-                        tessellator.setTranslation(-nextPosX, -nextPosY, -nextPosZ);
-                        tessellator.addVertexWithUV(x, j3, (double) z + 0.5D, 0.0F * f2, ((float) j3 * f2) / 4F - vOffset * f2);
-                        tessellator.addVertexWithUV(x + 1, j3, (double) z + 0.5D, f2, ((float) j3 * f2) / 4F - vOffset * f2);
-                        tessellator.addVertexWithUV(x + 1, l3, (double) z + 0.5D, f2, ((float) l3 * f2) / 4F - vOffset * f2);
-                        tessellator.addVertexWithUV(x, l3, (double) z + 0.5D, 0.0F * f2, ((float) l3 * f2) / 4F - vOffset * f2);
-                        tessellator.addVertexWithUV((double) x + 0.5D, j3, z, 0.0F * f2, ((float) j3 * f2) / 4F - vOffset * f2);
-                        tessellator.addVertexWithUV((double) x + 0.5D, j3, z + 1, f2, ((float) j3 * f2) / 4F - vOffset * f2);
-                        tessellator.addVertexWithUV((double) x + 0.5D, l3, z + 1, f2, ((float) l3 * f2) / 4F - vOffset * f2);
-                        tessellator.addVertexWithUV((double) x + 0.5D, l3, z, 0.0F * f2, ((float) l3 * f2) / 4F - vOffset * f2);
-                        tessellator.setTranslation(0.0D, 0.0D, 0.0D);
+                    } else {
+                        throw new IllegalStateException("Illegal weather type!");
                     }
+
+                    t.setTranslation(-lerpedX, -lerpedY, -lerpedZ);
+
+                    t.addVertexWithUV(x + 0.0, y0 + 0.0, z + 0.5, 0.0 + u, y0 / 4.0 + vOffset + v);
+                    t.addVertexWithUV(x + 1.0, y0 + 0.0, z + 0.5, 1.0 + u, y0 / 4.0 + vOffset + v);
+                    t.addVertexWithUV(x + 1.0, y1 + 0.0, z + 0.5, 1.0 + u, y1 / 4.0 + vOffset + v);
+                    t.addVertexWithUV(x + 0.0, y1 + 0.0, z + 0.5, 0.0 + u, y1 / 4.0 + vOffset + v);
+
+                    t.addVertexWithUV(x + 0.5, y0 + 0.0, z + 0.0, 0.0 + u, y0 / 4.0 + vOffset + v);
+                    t.addVertexWithUV(x + 0.5, y0 + 0.0, z + 1.0, 1.0 + u, y0 / 4.0 + vOffset + v);
+                    t.addVertexWithUV(x + 0.5, y1 + 0.0, z + 1.0, 1.0 + u, y1 / 4.0 + vOffset + v);
+                    t.addVertexWithUV(x + 0.5, y1 + 0.0, z + 0.0, 0.0 + u, y1 / 4.0 + vOffset + v);
+
+                    t.setTranslation(0.0, 0.0, 0.0);
                 }
             }
-            tessellator.draw();
         }
+
+        t.draw();
         GLRenderer.popFrame();
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
index 350195a42..30818842f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
@@ -5,6 +5,7 @@ import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.colorizer.Colorizer;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockColorWater extends BlockColorCustom {
@@ -17,7 +18,7 @@ public class BlockColorWater extends BlockColorCustom {
 	
 	@Override
 	public int getFallbackColor(int meta, int tintIndex) {
-		if(!GameSettings.BIOME_WATER.value || (this.mc.currentWorld != null && this.mc.currentWorld.isRetro())) {
+		if(!GameSettings.BIOME_WATER.value || (this.mc.currentWorld != null && this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.RETRO))) {
 			return 0xFFFFFFFF;
 		}
 		return super.getFallbackColor(meta, tintIndex);
@@ -25,10 +26,9 @@ public class BlockColorWater extends BlockColorCustom {
 	
 	@Override
 	public int getWorldColor(@NotNull WorldSource source, @NotNull TilePosc tilePos, int tintIndex) {
-		if(!GameSettings.BIOME_WATER.value || source.isRetro()) {
+		if(!GameSettings.BIOME_WATER.value || source.getWorldType().hasTag(WorldTypeTags.RETRO)) {
 			return 0xFFFFFFFF;
 		}
 		return super.getWorldColor(source, tilePos, tintIndex);
 	}
-
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
index 1ae54ebbe..266ea7636 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
@@ -9,6 +9,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.useless.dragonfly.DisplayPos;
@@ -41,6 +42,6 @@ public abstract class BlockModel<T extends BlockLogic> {
     }
 
     public boolean isRetro() {
-        return Minecraft.getMinecraft().currentWorld != null && Minecraft.getMinecraft().currentWorld.isRetro();
+        return Minecraft.getMinecraft().currentWorld != null && Minecraft.getMinecraft().currentWorld.getWorldType().hasTag(WorldTypeTags.RETRO);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java
index d700b8fcd..4dea57881 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render.dynamictexture;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.season.SeasonManagerCycle;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 
 public class DynamicTextureCalendar extends DynamicTextureAbstractClock {
 
@@ -15,7 +16,7 @@ public class DynamicTextureCalendar extends DynamicTextureAbstractClock {
 		double d = 0.0;
 		if (mc.currentWorld != null && mc.thePlayer != null)
 		{
-			if (mc.currentWorld.getSeasonManager() instanceof SeasonManagerCycle)
+			if (mc.currentWorld.getSeasonManager() instanceof SeasonManagerCycle && !mc.currentWorld.getWorldType().hasTag(WorldTypeTags.BREAKS_TIMEPIECES))
 			{
 				SeasonManagerCycle cycleManager = (SeasonManagerCycle) mc.currentWorld.getSeasonManager();
 				float f = cycleManager.getYearProgress() - 0.25f;
